/************************************************************************/
/* Projet : TP5								*/
/* Description : creation des tables					*/
/* Auteur : C.M. et D.R.			    			*/
/* Date de creation : 03/05/2001					*/
/* Date de mise a jour : 						*/
/************************************************************************/

if exists (select table_name from information_schema.tables where table_name='DETAIL_COMMANDE')
drop table DETAIL_COMMANDE
GO

if exists (select table_name from information_schema.tables where table_name='PRODUIT')
drop table PRODUIT
GO

if exists (select table_name from information_schema.tables where table_name='COMMANDE')
drop table COMMANDE
GO

if exists (select table_name from information_schema.tables where table_name='CATEGORIE')
drop table CATEGORIE
GO

if exists (select table_name from information_schema.tables where table_name='CLIENT')
drop table CLIENT
GO

/* creation de la table CLIENT */
create table CLIENT
	(Id_client int identity(1,1),
	Nom_client varchar(50),
	Prenom_client varchar(50),
	Adresse_client varchar(50),
	Postal_client char(5),
	Ville_client varchar(50),
	Region_client varchar(50),
	Tel_client char(10),
	Fax_client char(10),
	Email_client varchar(50),
	constraint pk_client primary key(Id_client)
	)
GO

/* creation de la table CATEGORIE */
create table CATEGORIE
	(Id_cat char(3),
	Nom_cat varchar(50),
	constraint pk_categorie primary key(Id_cat)
	)
GO


/* creation de la table PRODUIT */
create table PRODUIT
	(Id_prod char(20),
	Id_cat char(3),
	Titre_prod varchar(50),
	Detail_prod varchar(50),
	Image_prod varchar(50),
	Nouv_prod bit,
	Prom_prod bit,
	Sel_prod bit,
	Poids_prod numeric(8,2),
	Dispo_prod bit,
	Delai_prod varchar(50),
	Prixht_prod numeric(8,2),
	Prixhtprom_prod numeric(8,2),
	Tauxtva_prod numeric(8,2),
	constraint pk_produit primary key(Id_prod),
	constraint fk_prod_cat foreign key(Id_cat) references CATEGORIE(Id_cat)
	)
GO



/* creation de la table COMMANDE */
create table COMMANDE
	(Id_com int identity(1,1),
	Date_com datetime default getdate(),
	Id_client int,
	DateEnvoi_com datetime default getdate(),
	Id_paiement char(5),
	Ref_paiement varchar(50),
	Total_com numeric(8,2),
	constraint pk_commande primary key(Id_com),
	constraint fk_com_client foreign key(Id_client) references CLIENT(Id_client)
	)
GO



/* creation de la table DETAIL_COMMANDE */
create table DETAIL_COMMANDE
	(Id_prod char(20),
	Id_com int,
	Qt_dc numeric(8,2),
	Prix_dc numeric(8,2),
	constraint fk_det_prod foreign key(Id_prod) references PRODUIT(Id_prod),
	constraint fk_det_com foreign key(Id_com) references COMMANDE(Id_com),
	)
GO


