DROP TABLE travailler;
DROP TABLE projet;
DROP TABLE chercheur;
DROP TABLE equipe;

CREATE TABLE equipe
	(n_equipe 	VARCHAR(8),
	 nom_equipe 	VARCHAR(25),
	 CONSTRAINT pk_equipe PRIMARY KEY(n_equipe)
	);

CREATE TABLE chercheur
	(n_chercheur 	VARCHAR(11),
	 nom_chercheur	VARCHAR(10),
	 specialite 	VARCHAR(10),
	 universite 	NUMBER,
	 n_equipe	VARCHAR(8),
	 CONSTRAINT pk_chercheur PRIMARY KEY(n_chercheur),
	 CONSTRAINT fk_chercheur_eq FOREIGN KEY(n_equipe)
	 REFERENCES equipe(n_equipe)
	);
	 
CREATE TABLE projet
	(n_projet 	VARCHAR(8),
	 nom_projet 	VARCHAR(20),
	 n_equipe	VARCHAR(8),
	 n_cher_resp 	VARCHAR(11),
	 CONSTRAINT pk_projet PRIMARY KEY(n_projet),
	 CONSTRAINT fk_projet_eq FOREIGN KEY(n_equipe)
	 REFERENCES equipe(n_equipe),
	 CONSTRAINT fk_projet_cher FOREIGN KEY(n_cher_resp)
	 REFERENCES chercheur(n_chercheur)
	);

CREATE TABLE travailler
	(n_projet 	VARCHAR(8),
	 n_chercheur 	VARCHAR(11),
	 nb_jour_sem	NUMBER,
	 CONSTRAINT pk_travailler PRIMARY KEY(n_projet,n_chercheur),
	 CONSTRAINT fk_trav_proj FOREIGN KEY(n_projet)
	 REFERENCES projet(n_projet),
	 CONSTRAINT fk_trav_cher FOREIGN KEY(n_chercheur)
	 REFERENCES chercheur(n_chercheur)
	);
